########################################################################
#
#	NpEntryCsv.pl
#
#	y֐z
#	instance				
#
#	yz
#	Ver	1.00	2010.05.17	vx TY	VK쐬
#	Ver	1.10	2011.08.25	vx TY	EFuTCgɑΉB
#
#	Copyright (C) 2010 Shitaro Kubuki. All Rights Reserved
#
package MT::Plugin::NpEntryCsv;

use strict;
use MT;
use MT::Plugin;
use base qw( MT::Plugin );
use vars qw($PLUGIN_NAME $VERSION);
$PLUGIN_NAME = 'NAWAGATE plugin Click Pong Entry CSV basic';
$VERSION = '1.10';

my $plugin = MT::Plugin::NpEntryCsv->new({
    id => 'npentrycsv',
    key => __PACKAGE__,
    name => $PLUGIN_NAME,
    version => $VERSION,
    description => "<__trans phrase='Import / Export data of Entry(Page) by CSV format.'>",
    author_name => "<__trans phrase='Shintaro Kubuki'>",
    author_link => 'http://nawagate.com/',
    doc_link => 'http://appstream.jp/entry-csv/index.html',
    l10n_class => 'NpEntryCsv::L10N',
    registry => {
		applications => {
			cms => {
				methods =>
				{
					np_entry_csv_display_import => '$NpEntryCsv::NpEntryCsv::CMS::display_import',
					np_entry_csv_import => '$NpEntryCsv::NpEntryCsv::CMS::import',
					np_entry_csv_display_export => '$NpEntryCsv::NpEntryCsv::CMS::display_export',
					np_entry_csv_export => '$NpEntryCsv::NpEntryCsv::CMS::export',
				},
				menus =>
				{
					'tools:np_entry_csv_import' =>
					{
						label => 'CSV Entry Import',
						order => 10201,
						mode => 'np_entry_csv_display_import',
						view => "blog",
					},
					'tools:np_entry_csv_export' =>
					{
						label => 'CSV Entry Export',
						order => 10202,
						mode => 'np_entry_csv_display_export',
						view => "blog",
					},
				},
			},
		},
    },
});

MT->add_plugin($plugin);

sub instance { $plugin; }

1;
