########################################################################
#
#	CMS.pm
#
#	y֐z
#	display_import			C|[gʕ\
#	import					C|[g
#	display_export			GNX|[gʕ\
#	export					GNX|[g
#
#	yz
#	Ver	1.00	2010.05.17	vx TY	VK쐬
#	Ver	1.10	2011.08.25	vx TY	EFuTCgɑΉB
#
#	Copyright (C) 2010 Shitaro Kubuki. All Rights Reserved
#
package NpEntryCsv::CMS;

use strict;
use warnings;
use CustomFields::Util qw( get_meta save_meta );
use MT::Util qw( dirify );
use MT::Blog;
use MT::Author;
use MT::ObjectTag;
use MT::Placement;
use MT::I18N qw( guess_encoding encode_text );
use MT::Tag;
use MT::Folder;
use HTTP::Date;
use NpLibrary::CsvObject;
use NpLibrary qw( lib_get_dir_separator lib_doLog lib_get_system_charset lib_app_print lib_get_csv_items lib_get_item_id );

use vars qw( @ENTRY_CSVS @PAGE_CSVS $INDEX_ID $INDEX_TITLE );

# uOLCSVe[u z̏͗̏o͏ƂȂB
@ENTRY_CSVS = (
#								vpeB			ftHg		^Cg
	new NpLibrary::CsvObject(	'id',				'',				"Entry ID"																			),
	new NpLibrary::CsvObject(	'author_id',		'',				"User name(ID)"																		),
	new NpLibrary::CsvObject(	'title',			'',				"Title"																				),
	new NpLibrary::CsvObject(	'convert_breaks',	'',				"Format"																			),
	new NpLibrary::CsvObject(	'text',				'',				"Body"																				),
	new NpLibrary::CsvObject(	'text_more',		'',				"Extended"																			),
	new NpLibrary::CsvObject(	'excerpt',			'',				"Excerpt"																			),
	new NpLibrary::CsvObject(	'keywords',			'',				"Keywords"																			),
	new NpLibrary::CsvObject(	'status',			'',				"Status\n1:Unpublished\n2:Published"												),
	new NpLibrary::CsvObject(	'authored_on',		'',				"Publish Date"																		),
	new NpLibrary::CsvObject(	'basename',			'',				"Basename"																			),
	new NpLibrary::CsvObject(	'allow_comments',	'',				"Comment permission.\n0:Not permission\n1:permission"								),
	new NpLibrary::CsvObject(	'allow_pings',		'',				"Track back permission.\n0:Not permission\n1:permission"							),
	new NpLibrary::CsvObject(	'to_ping_urls',		'',				"Track back URL\n*Please change line when you register two or more destinations."	),
	new NpLibrary::CsvObject(	'pinged_urls',		'',				"Previously Sent TrackBacks URLs"													),
#	new NpLibrary::CsvObject(	'blog_id',			'',				"Blog ID"																			),
#	new NpLibrary::CsvObject(	'tangent_cache',	'',				"tangent cache"																		),
#	new NpLibrary::CsvObject(	'atom_id',			'',				"atom id"																			),
#	new NpLibrary::CsvObject(	'week_number',		'',				"week number"																		),
#	new NpLibrary::CsvObject(	'template_id',		'',				"template id"																		),
#	new NpLibrary::CsvObject(	'comment_count',	'',				"Comment count"																		),
#	new NpLibrary::CsvObject(	'ping_count',		'',				"Ping count"																		),
#	new NpLibrary::CsvObject(	'junk_log',			'',				"junk log"																			),
#	new NpLibrary::CsvObject(	'revision',			'',				"revision"																			),
#	new NpLibrary::CsvObject(	'category_id',		'',				"category id"																		),
);

# EFuy[WCSVe[u z̏͗̏o͏ƂȂB
@PAGE_CSVS = (
);

$INDEX_ID = 0;
$INDEX_TITLE = 2;

########################################################################
#
#	y֐z
#	display_import			C|[gʕ\
#
#	y@\z
#	C|[gʂ̕\s܂B
#
#	yz
#	Ver	1.00	2010.05.17	vx TY	VK쐬
#
sub display_import
{
	my $app = shift;
	my $blog_id = $app->param('blog_id');

	# uO̊Ǘ錠邩`FbNisuperuserj
	my $perms = $app->permissions;
	return $app->return_to_dashboard( permission => 1 )
	  if $perms
		  && ( !( $perms->can_edit_config || $perms->can_administer_blog ) );

	my %param;
	$param{blog_id} = $blog_id;
	my $view = $app->param('view') || 'blog';
	$param{view} = $view;
	$app->load_tmpl( 'entry_csv_import.tmpl', \%param );
}
########################################################################
#
#	y֐z
#	import					C|[g
#
#	y@\z
#	C|[g̃GWƂȂ鏈s܂B
#
#	yz
#	Ver	1.00	2010.05.17	vx TY	VK쐬
#
sub import
{
	my $app = shift;
    my $user    = $app->user;
	my $blog_id = $app->param('blog_id')
		or return $app->error( $app->translate('Please select a blog.') );
	my $class = $app->param('class')
		or return $app->error( $app->translate('Please select a entry type.') );
    my $blog = MT::Blog->load($blog_id)
		or return $app->error( $app->translate('Load of blog \'[_1]\' failed: [_2]', $blog_id, MT::Blog->errstr));
	$app->param('file') or return $app->error( $app->translate('Please input file name.') );

	# `FbN
		# uO̊ݒҏW錠邩`FbN
	my $perms = $app->permissions;
	return $app->error( $app->translate('You do not have export permissions') )
		unless $perms && $perms->can_edit_config;
		# magic_tokenHTTPp[^[L`FbN
	$app->validate_magic() or return;

 	# NX𔻒
	my $class_name = ($class eq 'entry') ? 'entry' : 'page';
	my $entry_class = MT->model($class_name);
	my @csv_objects = ($class eq 'entry') ? @ENTRY_CSVS : @PAGE_CSVS;

	my $q = $app->{query};
	my $fh = $q->upload('file');
	my @file = ();
	my $buffer = "";
	foreach my $record (<$fh>)
	{
		if ( MT->version_number >= 5 )
		{
			$buffer .= Encode::decode('shift_jis', $record);
		}
		else
		{
			$buffer .= encode_text($record, 'shift_jis', lib_get_system_charset($app));
		}
		next if ( ($buffer =~ s/"/"/g) % 2 );
		push( @file, $buffer );
		$buffer = "";
	}

	# ^O̓Yݒ
	my $tag_index = $#csv_objects + 1;
	# JeS̓Yݒ
	my $category_index = $#csv_objects + 2;

	$app->{no_print_body} = 1;

	local $| = 1;
	$app->send_http_header('text/html');

	my $param;

	lib_app_print($app, $app->build_page( 'entry_csv_import_start.tmpl', $param ) );

	# ^Cgs̐ǂ
	my @custom_ids = ();
	foreach my $record (@file)
	{
		my @items = lib_get_csv_items( $file[0], ',' );
		if ( $items[$INDEX_ID] eq $app->translate( $csv_objects[0]->{title} ) )
		{
			shift( @file );
		}
		last;
	}
	# Csvt@C`FbN
	my $error = 0;
	my $row = 0;
	foreach my $record (@file)
	{
		$row++;
		my @items = lib_get_csv_items( $record, ',' );
		for (my $index = 0; $index < $#csv_objects + 1; $index++)
		{
			my $property_name = $csv_objects[$index]->{property_name};
			my $value = $items[$index];
			# LID
			if ( $property_name eq 'id' )
			{	# ݃`FbN
				next if ( $value eq '' );
				my $entry = $entry_class->load( $value );
				unless ( $entry )
				{
					if ($class eq 'entry')
					{
						lib_app_print($app, $app->translate( "Error: Entry link to Entry ID not found. Row.[_1] ([_2])", $row, $items[$INDEX_TITLE]) . "\n" );
					}
					else
					{
						lib_app_print($app, $app->translate( "Error: Page link to Page ID not found. Row.[_1] ([_2])", $row, $items[$INDEX_TITLE]) . "\n" );
					}
					$error = 1;
				}
			}
			# x[Xl[
			if ( $property_name eq 'basename' )
			{
				next if ( $value eq '' );
				# d`FbNiEFuy[Ŵ݁j
				if ( $class eq 'page')
				{
					my $folder = MT::Folder->load( lib_get_item_id( $items[$category_index] ) );
					my $save_publish_path = defined $folder ? $folder->publish_path() : '';
					my $term = { class => 'page', blog_id  => $blog_id, basename => $value, id => $items[$INDEX_ID], };
					my $arg = { not => { id => 1 }, };
					my $iter = MT::Page->load_iter( $term , $arg );
					while ( my $page = $iter->() )
					{
						$folder = $page->folder;
						my $publish_path = defined $folder ? $folder->publish_path() : '';
						if ( $publish_path eq $save_publish_path )
						{
							lib_app_print($app, $app->translate("Error: The page basename \'[_3]\' conflicts with another page. Pages with the same parent must have unique basenames. Row.[_1] ([_2])", $row, $items[$INDEX_TITLE], $value) . "\n" );
							$error = 1;
						}
					}
				}
			}
			# [U[
			if ( $property_name eq 'author_id' )
			{	# ݃`FbN
				next if ( $value eq '' );
				my $author = MT::Author->load( lib_get_item_id( $value ) );
				unless ( $author )
				{
					$value =~ s/\((\d+)\)$//;
					$author = MT::Author->load( {name => $value,} );
					unless ( $author )
					{
						lib_app_print($app, $app->translate("Error: User not found. Row.[_1] ([_2])", $row, $items[$INDEX_TITLE]) . "\n" );
						$error = 1;
					}
				}
			}
		}
	}
	if ( $error == 1 )
	{
		lib_app_print($app, $app->build_page( "entry_csv_import_end.tmpl", $param ) );
		return 1;
	}

	# o^
	foreach my $record (@file)
	{
		my @items = lib_get_csv_items( $record, ',' );
		# L
		my $entry = $entry_class->load( $items[$INDEX_ID] );
		unless ( $entry )
		{
			$entry = $entry_class->new;
		}
			# uOID
		$entry->blog_id( $blog_id );
			# ̑
		for (my $index = 0; $index < $#csv_objects + 1; $index++)
		{
			my $property_name = $csv_objects[$index]->{property_name};
			my $default = $csv_objects[$index]->{default};
			my $value = $items[$index];
			# id ͏㏑Ȃ
			next if ( $property_name eq 'id' );
			if ($entry->column_defs->{$property_name}->{'type'} eq 'datetime')
			{
				my $time = HTTP::Date::str2time( $value );
				next unless ( $time );
				my @times = MT::Util::offset_time_list( $time, $blog_id );
				$value = sprintf( "%04d%02d%02d%02d%02d%02d", $times[5]+1900, $times[4]+1, @times[3,2,1,0] );
			}
			if ( $property_name eq 'author_id' )
			{
				if ( $value eq '' )
				{
					$value = $user->id;
				}
				else
				{
					my $author = MT::Author->load( lib_get_item_id( $value ) );
					unless ( $author )
					{
						$value =~ s/\((\d+)\)$//;
						$author = MT::Author->load( {name => $value,} );
					}
					if ( $author )
					{
						$value = $author->id;
					}
					else
					{
						$value = $user->id;
					}
				}
			}
			if ( ( $default ne '' ) && ( $value eq '' ) )
			{
				$value = $blog->$default;
			}
			$entry->$property_name($value);
		}
		$entry->save;
		# ^O
		my @object_tags = MT::ObjectTag->load( { blog_id => $blog_id, object_datasource => $entry->datasource, object_id => $entry->id } );
			# Ώۂ̋L̃^OSč폜
		foreach my $object_tag (@object_tags)
		{
			$object_tag->remove;
		}
			# Ώۂ̋L̃^Oo^
		my @tag_names = lib_get_csv_items( $items[$tag_index], '|' );
		foreach my $tag_name (@tag_names)
		{
			next if ( $tag_name eq '');
			my $tag = MT::Tag->load( lib_get_item_id( $tag_name ) );
			unless ( $tag )
			{
				$tag_name =~ s/\((\d+)\)$//;
				$tag = MT::Tag->load( { name => $tag_name } );
				unless ( $tag )
				{
					$tag = MT::Tag->new;
					$tag->name($tag_name);
					$tag->save or next;
				}
			}
			my $object_tag = MT::ObjectTag->new;
			$object_tag->object_id( $entry->id );
			$object_tag->blog_id( $blog_id );
			$object_tag->tag_id( $tag->id );
			$object_tag->object_datasource( $entry->datasource );
			$object_tag->save or next;
		}
		# JeS
		my @placements = MT::Placement->load( { blog_id => $blog_id, entry_id => $entry->id } );
			# Ώۂ̋L̃JeSSč폜
		foreach my $placement (@placements)
		{
			$placement->remove;
		}
			# Ώۂ̋L̃JeSo^
		my @category_labels = lib_get_csv_items( $items[$category_index], '|' );
		if ($class_name eq 'page' && @category_labels)
		{
			$buffer = $category_labels[0];
			@category_labels = ();
			push( @category_labels, $buffer );
		}
		my $category_class = MT->model( ($class eq 'entry') ? 'category' : 'folder' );
		my $first = 0;
		foreach my $category_label (@category_labels)
		{
			next if ( $category_label eq '');
			my $category = $category_class->load( lib_get_item_id( $category_label ) );
			unless ( $category )
			{
				$category_label =~ s/\((\d+)\)$//;
				$category = $category_class->load({ blog_id => $blog_id, label => $category_label });
				unless ( $category )
				{
					$category = $category_class->new;
					$category->blog_id($blog_id);
					$category->label($category_label);
					$category->save or next;
				}
			}
			my $placement = MT::Placement->new;
			$placement->entry_id( $entry->id );
			$placement->blog_id( $blog_id );
			$placement->category_id( $category->id );
			$placement->is_primary( 0 );
			if ( $first == 0 )
			{
				$placement->is_primary( 1 );
				$first = 1;
			}
			$placement->save or next;
		}
		# o
		if ( $class eq 'entry' )
		{
			lib_app_print($app, $app->translate("Data of entry imported. ID.[_1] ([_2])", $entry->id, $entry->title) . "\n" );
		}
		else
		{
			lib_app_print($app, $app->translate("Data of page imported. ID.[_1] ([_2])", $entry->id, $entry->title) . "\n" );
		}
	}

	$param->{import_success} = '1';
	lib_app_print($app, $app->build_page( "entry_csv_import_end.tmpl", $param ) );

	close $fh if $fh;

	return 1;

}
########################################################################
#
#	y֐z
#	display_export			GNX|[gʕ\
#
#	y@\z
#	GNX|[gʂ̕\s܂B
#
#	yz
#	Ver	1.00	2010.05.17	vx TY	VK쐬
#
sub display_export
{
	my $app = shift;
	my $blog_id = $app->param('blog_id');

	# uO̊Ǘ錠邩`FbNisuperuserj
	my $perms = $app->permissions;
	return $app->return_to_dashboard( permission => 1 )
	  if $perms
		  && ( !( $perms->can_edit_config || $perms->can_administer_blog ) );

	my %param;
	$param{blog_id} = $blog_id;
	my $view = $app->param('view') || 'blog';
	$param{view} = $view;
	$app->load_tmpl( 'entry_csv_export.tmpl', \%param );
}
########################################################################
#
#	y֐z
#	export					GNX|[g
#
#	y@\z
#	GNX|[g̃GWƂȂ鏈s܂B
#
#	yz
#	Ver	1.00	2010.05.17	vx TY	VK쐬
#
sub export
{
	my $app = shift;
	my $blog_id = $app->param('blog_id')
		or return $app->error( $app->translate('Please select a blog.') );
	my $class = $app->param('class')
		or return $app->error( $app->translate('Please select a entry type.') );
    my $blog = MT::Blog->load($blog_id)
		or return $app->error(
			$app->translate(
				'Load of blog \'[_1]\' failed: [_2]', $blog_id,
				MT::Blog->errstr
			)
		);

	# `FbN
		# uO̊ݒҏW錠邩`FbN
	my $perms = $app->permissions;
	return $app->error( $app->translate('You do not have export permissions') )
		unless $perms && $perms->can_edit_config;
		# magic_tokenHTTPp[^[L`FbN
	$app->validate_magic() or return;

	# NX𔻒
	my $class_name = ($class eq 'entry') ? 'entry' : 'page';
	my $entry_class = MT->model($class_name);
	my @csv_objects = ($class eq 'entry') ? @ENTRY_CSVS : @PAGE_CSVS;

	# CSV t@C̐
	my $file = dirify( $blog->name );
	my @ts = localtime(time);
	if ( $file ne '' )
	{
		$file = sprintf( "%s-%s-%04d%02d%02d%02d%02d%02d.csv",
			$class, $file, $ts[5] + 1900, $ts[4] + 1, @ts[ 3, 2, 1, 0 ]);
	}
	else
	{
		$file = sprintf( "%s-blog_id_%03d-%04d%02d%02d%02d%02d%02d.csv",
			$class, $app->param('blog_id'), $ts[5] + 1900, $ts[4] + 1, @ts[ 3, 2, 1, 0 ]);
	}

	printf( "Content-Type: application/octet-stream\n" );
	printf( "Content-Disposition: attachment; filename=%s\n", $file );
	printf( "\n" );

	# ^Cgs̐
	my @buffer = ();
		# L
	foreach my $csv_object (@csv_objects)
	{
		push( @buffer, encode_text( $app->translate( $csv_object->{title}), lib_get_system_charset($app), 'shift_jis') );
	}
		# ^O
	push( @buffer, encode_text( $app->translate( "Tags(ID)\n*Please delimit it by \"|\" when you input items."), lib_get_system_charset($app), 'shift_jis' ) );
		# JeS
	if ( $class eq 'entry' )
	{
		push( @buffer, encode_text( $app->translate( "Categories(ID)\n*Please delimit it by \"|\" when you input items."), lib_get_system_charset($app), 'shift_jis' ) );
	}
	else
	{
		push( @buffer, encode_text( $app->translate( "Folders(ID)\n*Please delimit it by \"|\" when you input items."), lib_get_system_charset($app), 'shift_jis' ) );
	}
		# ^Cgs̏o
	my $buffer = join( ',', map( {(s/"/""/g or /[\r\n,]/) ? qq("$_") : (/[\D]/) ? qq("$_") : qq("'$_")} @buffer ) );
	printf( "%s\n", $buffer );

	# ڍ׍s̐
	my @entries = $entry_class->load({ blog_id => $blog_id });
	foreach my $entry (@entries)
	{
		# 
		@buffer = ();
		# L
		my $column_names = $entry->column_names;
		my @column_names = @$column_names;

		my %values = ();
		foreach my $column_name ( @column_names )
		{
			if ( $entry->column_defs->{$column_name}->{'type'} eq 'datetime' )
			{
				$values{$column_name} = MT::Util::format_ts( '%Y-%m-%d %H:%M:%S', $entry->$column_name, undef );
				next;
			}
			if ( $column_name eq 'author_id' )
			{
				$values{$column_name} = '';
				my $author = MT::Author->load( $entry->$column_name );
				if ( $author )
				{
					$values{$column_name} = $author->name . '(' . $author->id . ')';
				}
				next;
			}
			$values{$column_name} = $entry->$column_name;
		}
		foreach my $csv_object (@csv_objects)
		{
			if ( exists($values{$csv_object->{property_name}}) )
			{
				push( @buffer, $values{$csv_object->{property_name}} );
			}
			else
			{
				push( @buffer, "" );
			}
		}
		# ^O
		my @tags = ();
		my @object_tags = MT::ObjectTag->load( { blog_id => $blog_id, object_datasource => $entry->datasource, object_id => $entry->id } );
		for my $object_tag (@object_tags)
		{
			my $tag = MT::Tag->load( $object_tag->tag_id ) or next;
			push( @tags, $tag->name . '(' . $object_tag->tag_id . ')' );
		}
		push( @buffer, join( '|', @tags ) || '' );
		# JeS
		my $category_class = MT->model( ($class eq 'entry') ? 'category' : 'folder' );
		my @categories = ();
		my @placements = MT::Placement->load( { blog_id => $blog_id, entry_id => $entry->id } );
		for my $placement (@placements)
		{
			my $category = $category_class->load( $placement->category_id ) or next;
			if ( $placement->is_primary )
			{
				unshift( @categories, $category->label . '(' . $placement->category_id . ')' );
			}
			else
			{
				push( @categories, $category->label . '(' . $placement->category_id . ')' );
			}
		}
		push( @buffer, join( '|', @categories ) || '' );
		# ڍ׍s̏o
		$buffer = join( ',', map( {(s/"/""/g or /[\r\n,]/) ? qq("$_") : (/[\D]/) ? qq("$_") : qq("'$_")} @buffer ) );
		$buffer = encode_text($buffer, lib_get_system_charset($app), 'shift_jis');
		printf( "%s\n", $buffer );
	}

	exit;
}

1;
