########################################################################
#
#	ja.pm
#
#	【関数】
#
#	【履歴】
#	Ver	1.00	2010.05.17	久富木 慎太郎	新規作成
#	Ver	1.10	2011.08.25	久富木 慎太郎	ウェブサイトに対応。
#
#	Copyright (C) 2010 Shitaro Kubuki. All Rights Reserved
#
package NpEntryCsv::L10N::ja;

use strict;

use base 'NpEntryCsv::L10N::en_us';
use vars qw( %Lexicon );

require utf8 if (MT->version_number >= 5); 


# The following is the translation table.
%Lexicon = (
## NpEntryCsv.pl
	'Import / Export data of Entry(Page) by CSV format.' => 'CSV形式でブログ記事（ウェブページ）の情報をインポート／エクスポートします。',
	'Shintaro Kubuki' => '久富木 慎太郎',
	'CSV Entry Import' => 'CSV記事インポート',
	'CSV Entry Export' => 'CSV記事エクスポート',

## lib/NpEntryCsv/CMS.pm
	'Entry ID' => 'ブログ記事ID',
	'Page ID' => 'ウェブページID',
	'User name(ID)' => 'ユーザー名(ID)',
	'Title' => 'タイトル',
	'Format' => 'フォーマット',
	'Body' => '本文',
	'Extended' => '続き',
	'Excerpt' => '概要',
	'Keywords' => 'キーワード',
	"Status\n1:Unpublished\n2:Published" => "状態\n1:未公開\n2:公開",
	'Publish Date' => '公開日',
	'Basename' => '出力ファイル名',
	"Comment permission.\n0:Not permission\n1:permission" => "コメントを許可\n0：許可しない\n1：許可する",
	"Track back permission.\n0:Not permission\n1:permission" => "トラックバックを許可\n0：許可しない\n1：許可する",
	"Track back URL\n*Please change line when you register two or more destinations." => "トラックバックURL\n※複数の送信先を登録する場合は、改行してください。",
	'Previously Sent TrackBacks URLs' => '送信済みのトラックバックURL',
	'Please select a blog.' => 'ブログを選択してください。',
	'Please select a entry type.' => 'ブログ記事タイプを選択してください。',
	'Load of blog \'[_1]\' failed: [_2]' => 'ブログ(ID:[_1])をロードできませんでした: [_2]',
	'Please input file name.' => 'インポートファイルを入力してください。',
	'You do not have export permissions' => 'エクスポートする権限がありません。',
	'Error: Entry link to Entry ID not found. Row.[_1] ([_2])' => 'Error: ブログ記事IDに対応するブログ記事が見つかりませんでした。Row.[_1] ([_2])',
	'Error: Page link to Page ID not found. Row.[_1] ([_2])' => 'Error: ウェブページIDに対応するウェブページが見つかりませんでした。Row.[_1] ([_2])',
	'Error: The page basename \'[_3]\' conflicts with another page. Pages with the same parent must have unique basenames. Row.[_1] ([_2])' => 'Error: 名前\'[_3]\'は他のウェブページと衝突しています。同じ階層にあるウェブページのベースネームは一意でなければなりません。Row.[_1] ([_2])',
	'Error: User not found. Row.[_1] ([_2])', => 'Error: ユーザーが見つかりませんでした。Row.[_1] ([_2])',
	'Data of entry imported. ID.[_1] ([_2])', => 'ブログ記事の情報をインポートしました。ID.[_1]([_2])',
	'Data of page imported. ID.[_1] ([_2])', => 'ウェブページの情報をインポートしました。ID.[_1]([_2])',
	"Tags(ID)\n*Please delimit it by \"|\" when you input items." => "タグ(ID)\n※複数項目を入力する場合は「|」で区切ってください。",
	"Categories(ID)\n*Please delimit it by \"|\" when you input items." => "カテゴリ(ID)\n※複数項目を入力する場合は「|」で区切ってください。",
	"Folders(ID)\n*Please delimit it by \"|\" when you input items." => "フォルダ(ID)\n※複数項目を入力する場合は「|」で区切ってください。",

## tmpl/csv_import.tmpl
	'You must select a blog to import.' => 'インポート先のブログを選択してください。',
	'ENTRY_IMPORT_MESSAGE' => '
Movable TypeにCSV形式のブログ情報をインポートします。<br />
基本的なデータ（タイトルや本文、トラックバック、カスタムフィールド）を上書き、または新規作成できます。<br />
<br />
インポートの仕様については以下のとおりとなります。<br />
・CSVのフォーマットはカンマ区切り（Microsoft Office ExcelにCSV形式に準拠）<br />
・１つのセルに複数の値がある場合は「|」区切り<br />
・ブログIDとユーザーIDの存在チェック以外のエラーは無視します。<br />
・ブログIDが空白の場合、ブログを新規作成します。<br />
・ブログIDが存在する場合は該当ブログを上書きします。<br />
・カスタムフィールドが対応しない場合はその列を無視します。<br />
	',

	'Import data into' => 'インポート先',
	'Select a blog to import.' => 'インポート先のブログを選択してください。',
	'Select blog' => 'ブログを選択してください。',
	'Entry Type' => 'ブログ記事のタイプ',
	'Entry' => 'ブログ記事',
	'Page' => 'ウェブページ',
	'Import file' => 'インポートファイル',
	'Please upload import file here.' => 'インポートファイルをここにアップロードしてください。',
	'More options' => 'その他のオプション',
	'Import File Encoding' => 'インポートするファイルの文字コード',
	'By default, Movable Type will attempt to automatically detect the character encoding of your import file.  However, if you experience difficulties, you can set it explicitly.' => '',
	'Import Entry(Page) (s)' => 'ブログ記事（ウェブページ）をインポート (s)',
	'Import Entry(Page)' => 'ブログ記事（ウェブページ）をインポート',

## tmpl/csv_import_start.tmpl
	'Importing...' => 'インポートを開始します...',
	'Importing entries(pages)' => 'ブログ記事（ウェブページ）をインポートしています',
	'Importing as user \'[_1]\'' => 'ユーザー[_1]としてインポートしています',

## tmpl/csv_import_end.tmpl
	'All data imported successfully!' => 'すべてのデータをインポートしました。',
	'An error occurred during the import process. Please check your import file.' => 'インポートの途中でエラーが発生しました。インポートファイルを確認してください。',

## tmpl/csv_export.tmpl
	'You must select a blog to export.' => 'エクスポートするブログを選択してください。',
	'ENTRY_EXPORT_MESSAGE' => '
Movable Typeからブログ記事をCSV形式でエクスポートします。<br />
基本的なデータ（タイトルや本文、トラックバック、カスタムフィールド）をダウンロードできます。<br />
<br />
エクスポートの仕様については以下のとおりとなります。<br />
・CSVのフォーマットはカンマ区切り（Microsoft Office ExcelにCSV形式に準拠）<br />
・１つのセルに複数の値がある場合は「|」区切り<br />
',
#ブログ記事
	'Blog to Export' => 'エクスポートするブログ',
	'Select a blog for exporting.' => 'エクスポートするブログを選択してください。',
	'Change blog' => 'ブログを変更',
	'Select blog' => 'ブログを選択',
	'Entry' => 'ブログ記事',
	'Page' => 'ウェブページ',
	'Export Entry(Page) (s)' => 'ブログ記事（ウェブページ）をエクスポート (s)',
	'Export Entry(Page)' => 'ブログ記事（ウェブページ）をエクスポート',
);

1;
